'***********************************************************
'*         "SKELETON" CODE FOR MULTI-BBS DOORS             *
'***********************************************************
'*   This code will open your door, handle all comm I/O    *
'*   monitor carrier, trap errors, and redeposit you safely*
'*   in your BBS in the event of serious problems.         *
'*                                                         *
'*   The code has relied upon information from RBBS, PCB,  *
'*   Wildcat!, and QBBS developers about file structures   *
'*   for versions that may not yet have been released.     *
'*                                                         *
'*   The skeleton should result in code that will work     *
'*   under a variety of BBS software (RBBS, PCBoard,       *
'*   Wildcat!, QBBS (and others using Bob Wescott's        *
'*   DORINFOx.DEF scheme))                                 *
'*                                                         *
'*   The I/O routines follow almost exactly the code as    *
'*   developed by John Morris.  Other concepts scrounged   *
'*   from Bob Wescott.  Examples of working code from      *
'*   other doors used too.  98% of the credit, however     *
'*   belongs to Mssr. Morris for the I/O code.             *
'***********************************************************
'*   If you're writing doorware, then this skeleton code   *
'*   will take most of the burden from your shoulders.     *
'*                                                         *
'*   your code will go where indicated.  As control is     *
'*   turned over to your code, the user will have been     *
'*   recognized, the comm link established, and monitoring *
'*   is in place.                                          *
'*                                                         *
'*   when input is required from the user, GOSUB 400, then *
'*   the user's input is in the string A$                  *
'*                                                         *
'*   when output is to be sent to the user, load the output*
'*   into A$ and then: GOSUB 80 (to mirror the effect of   *
'*   a BASIC statement PRINT A$) or GOSUB 100 (to mirror   *
'*   the effect of PRINT A$;)                              *
'*                                                         *
'*   the F10 key begins CHAT mode (ESC quits)              *
'*   the F9  key toggles "snoop" on or off                 *
'*   the F8  key allows you to boot the user off           *
'*                                                         *
'*   You needn't worry whether the caller can support      *
'*   color -- in fact, assume the caller CAN support color.*
'*                                                         *
'*   prior to a GOSUB 80 (or GOSUB 100) you can control    *
'*   the appearance of the caller's output thru several    *
'*   variables:                                            *
'*              FC =    (set foreground color)             *
'*              BC =    (set background color)             *
'*   [both of the above remain fixed until changed]        *
'*                                                         *
'*              BLINK = (0 for normal, 1 for blinking)     *
'*              HIGH  = (0 for normal, 1 for hi intensity  *
'*   [both of the above reset EACH time GOSUB 80 executed] *
'*                                                         *
'*   if user set as non-color caller special effects and   *
'*   colors are ignored.                                   *
'***********************************************************

' THE SKELETON CODE WILL USE FILE #3 FOR COMMUNICATIONS



' avoid use of the following variables in your own code
DIM SHARED C.OLOR(32)
COMMON SHARED BACKSP$, BK.ARW$, BC, BP$, C.OLOR(), CR$, CS$
COMMON SHARED COLOR.RESET$, COLOR.NORMAL$
COMMON SHARED COM.PORT$, DOOR.USERS.NAME$
COMMON SHARED FC, FORCESPEED, GRP, LF$, LOG.OFF$
COMMON SHARED L.OCAL, MESSAGE.FILE$, NODE, NODE.ID$
COMMON SHARED PAR, PCB14, RD$, RBBS.NAME$
COMMON SHARED SCOREBOARD.FILE$, SYSOP.FIRST$, SYSOP.LAST$
COMMON SHARED Snoop, TIME.SAVE


'***********************************************************
' add your own declarations and non-executable code here
'***********************************************************


' variables which you may want to refer to in your
' own code (which will be initialized by skeleton) include:
'
'  DOOR.USERS.NAME$  the full user's name, TRAILING BLANKS
'  SYSOP.FIRST$
'  SYSOP.LAST$
'  USERS.NAME$  the user's name, 1st letters capitals, no 
'               trailing blanks
'  FIRST$       USER'S FIRST NAME
'  LAST$        USER'S LAST NAME



DEF FNTI! = CSNG(FIX((VAL(MID$(TIME$, 1, 2)) * 3600) + (VAL(MID$(TIME$, 4, 2)) * 60) + (VAL(MID$(TIME$, 7, 2)) * 1)))


  RANDOMIZE TIMER
  KEY(8) ON
  KEY(9) ON
  KEY(10) ON
  ON KEY(8)  GOSUB Forceoff
  ON KEY(9)  GOSUB Snoop
  ON KEY(10) GOSUB Chatter
  FALSE = 0
  TRUE = NOT FALSE
  ON ERROR GOTO Err.routine


'***********************************************************
' a variable that you will want to set here for your
' door is:
'             DOOR.NAME$ ... set this to a SHORT name
'                            for your door
'***********************************************************

	 ROW% = 0: COL% = 0
	 C.OLOR(0) = 0   'black
	 C.OLOR(1) = 4   'red
	 C.OLOR(2) = 2   'green
	 C.OLOR(3) = 6   'yellow (brown)
	 C.OLOR(4) = 1   'blue
	 C.OLOR(5) = 5   'magenta
	 C.OLOR(6) = 3   'cyan
	 C.OLOR(7) = 7   'white
	 C.OLOR(8) = 8   'grey
	 C.OLOR(9) = 12  'light red
	 C.OLOR(10) = 10 'light green
	 C.OLOR(11) = 14 'yellow
	 C.OLOR(12) = 9  'light blue
	 C.OLOR(13) = 13 'light magenta
	 C.OLOR(14) = 11 'light cyan
	 C.OLOR(15) = 15 'white
	 C.OLOR(16) = 16 'black      (blink)
	 C.OLOR(17) = 20 'red        (blink)
	 C.OLOR(18) = 18 'green      (blink)
	 C.OLOR(19) = 22 'yellow     (blink)
	 C.OLOR(20) = 17 'blue       (blink)
	 C.OLOR(21) = 21 'magenta    (blink)
	 C.OLOR(22) = 19 'cyan       (blink)
	 C.OLOR(23) = 23 'white      (blink)
	 C.OLOR(24) = 24 'grey       (blink)
	 C.OLOR(25) = 28 'light red  (blink)
	 C.OLOR(26) = 26 'lght green (blink)
	 C.OLOR(27) = 30 'yellow     (blink)
	 C.OLOR(28) = 25 'light blue (blink)
	 C.OLOR(29) = 29 'lt magenta (blink)
	 C.OLOR(30) = 27 'lt cyan    (blink)
	 C.OLOR(31) = 31 'white      (blink)


'  *******************************************************
'  comments on command line structure:
'    if running on an RBBS system and if NOT on node 1,
'     then first argument MUST be node # ... other system
'     types may ignore that requirement.  If running RBBS
'     and using the DORINFOx.DEF file, the NODE # is
'     STRONGLY recommended.  Other types of software using
'     DORINFOx.DEF files should NOT use this parameter.
'
'    if running PCBoard 14 then the parameter /P=14 must
'    appear on the command line
'
'    if the modem is "locked" at some speed (speed between
'    bbs system and modem is constant, speed negotiated with
'    user by modem -- as might be done with an HST 9600)
'    then the parameter /C alone forces port to 19200, or
'    you may specify speed too -- e.g. /C=19200
'  *******************************************************


FOR.SURE.RBBS = 0
'read command line
	RD$ = COMMAND$
	NODE = VAL(RD$)
	IF NODE > O THEN FOR.SURE.RBBS = -1
	NODE = NODE + 1
	IF NODE < 2 THEN NODE = 2
	NODE.ID$ = STR$(NODE - 1)
	PCB14 = 0
	IF INSTR(RD$,"/P=14")>0 THEN PCB14 = -1
	FORCESPEED=0
	IF INSTR(RD$,"/C")>0 THEN
	  FORCESPEED = 19200
	  IF INSTR(RD$,"/C=")>0 THEN
	   X$ = MID$(RD$,INSTR(RD$,"/C=")+3,5)
	   IF LEN(X$)>0 THEN FORCESPEED = VAL(X$)
	  END IF
	END IF
	RD$ = NODE.ID$

'  *******************************************************
'    the existence of a file "DOOR.DEF" is assumed, in the
'    current directory.  This is a plain ASCII text file,
'    with 8 lines:
'    1. sysop's first name
'    2. sysop's last name
'    3. the path\filename of the file holding
'       information about the caller -- e.g.
'       C:\bbs\messages   <=== for RBBS system
'       [other filetypes supported:
'        CALLINFO.BBS  -- Wildcat!
'        DORINFOx.DEF  -- QBBS and others
'        PCBOARD.SYS   -- PCBoard 12 & 14]
'    4. COM1 or COM2
'    5. the BBS name running the door
'    6. the path\filename for the door's scoreboard
'       if your door will not HAVE a scoreboard then
'       this line may be omitted from the file AND then
'       you wouldn't read it below either.
'    7. idle minutes allowed before "sleep disconnect"
'       if no input received from user
'    8. max # minutes user allowed in door
'  *******************************************************

1001 OPEN "DOOR.DEF" FOR INPUT AS #1
	 INPUT #1, SYSOP.FIRST$
	 INPUT #1, SYSOP.LAST$
	 INPUT #1, MESSAGE.FILE$
	 INPUT #1, COM.PORT$
	 INPUT #1, RBBS.NAME$
	 INPUT #1, LOG.OFF$
	 INPUT #1, MAXTM$
	 NM.TIME = VAL(MAXTM$)
	 CLOSE 1

	  IF COM.PORT$ = "COM1" THEN
		 MCR = &H3FC
		 MSR = &H3FE
		 GOTO NEXTCASE
	  END IF
	  MCR = &H2FC
	  MSR = &H2FE

NEXTCASE:
' SEE IF PCBOARD ....

IF (RIGHT$(MESSAGE.FILE$,3)="SYS") OR (RIGHT$(MESSAGE.FILE$,3) = "sys") THEN GOTO PCBOARDS
GOTO WILDCATTEST

PCBOARDS:
1002 OPEN "R", 1, MESSAGE.FILE$
	FIELD 1, 128 AS Z$

	    IF PCB14 <> 0 THEN
		GET 1,1
		GRP = 1
		 BP$ = MID$(Z$,19,5)    'BAUD RATE
		GRP$ =MID$(Z$,12,1)
		IF GRP$ = "Y" THEN
		  GRP = 2
		END IF
		PAR = -1
		Snoop = VAL(LEFT$(Z$,2))
		DOOR.USERS.NAME$= MID$(Z$,85,25)
		GOTO WRAP.UP
	   END IF
	                           'PCB12 FORMAT
		 GET 1,1
		 BP$ = MID$(Z$,11,4)    'BAUD RATE
		 GRP = VAL(MID$(Z$,57,2))
		 IF GRP THEN
		  GRP = 2
		 END IF
		 PAR = -1
		 Snoop = VAL(LEFT$(Z$,2))
		 DOOR.USERS.NAME$= MID$(Z$,15,27)
		 GOTO WRAP.UP


WILDCATTEST:
' SEE IF WILDCAT! ...
	IF RIGHT$(MESSAGE.FILE$,3)="BBS" OR RIGHT$(MESSAGE.FILE$,3) = "bbs" THEN

1003     OPEN MESSAGE.FILE$ FOR INPUT AS #1
	    LINE INPUT #1, DOOR.USERS.NAME$
	    IF DOOR.USERS.NAME$ = "Sysop" THEN
	       DOOR.USERS.NAME$ = "SYSOP"
	    END IF
	    DOOR.USERS.NAME$ = DOOR.USERS.NAME$ + "   "
	    LINE INPUT #1, DUMMY$ ' BAUD CODE
	    LINE INPUT #1, DUMMY$ ' CALLING FROM
	    LINE INPUT #1, DUMMY$ ' SECURITY LEVEL
	    LINE INPUT #1, DUMMY$ ' TIME REMAINING
	    LINE INPUT #1, DUMMY$
	     GRP = 1
	     IF LEFT$(DUMMY$,3) = "COL" THEN GRP=2
	    LINE INPUT #1, DUMMY$ ' PASSWORD
	    LINE INPUT #1, DUMMY$ ' USER REC NUM
	    LINE INPUT #1, DUMMY$ ' MINUTES ONLINE
	    LINE INPUT #1, DUMMY$ ' TIME ENTERED DOOR
	    LINE INPUT #1, DUMMY$ ' TIME CALLED
	    LINE INPUT #1, DUMMY$ ' CONF JOINED
	    LINE INPUT #1, DUMMY$ ' DL FILE TOTL
	    LINE INPUT #1, DUMMY$ ' DAILY DL LIMIT
	    LINE INPUT #1, DUMMY$ ' DL K TOTL
	    LINE INPUT #1, DUMMY$ ' MAX DL LIMIT
	    LINE INPUT #1, DUMMY$ ' USER TELEPH #
	    LINE INPUT #1, DUMMY$ ' TIME/DATE LAST CALL
	    LINE INPUT #1, DUMMY$ ' NOV/EXPERT
	    LINE INPUT #1, DUMMY$ ' PROTOCOL
	    LINE INPUT #1, DUMMY$ ' LAST NEW FILE SEARCH
	    LINE INPUT #1, DUMMY$ ' # SIGNONS
	    LINE INPUT #1, DUMMY$ ' LINES/PAGE
	    LINE INPUT #1, DUMMY$ ' LAST MSG READ
	    LINE INPUT #1, DUMMY$ ' TOTL UPLOAD
	    LINE INPUT #1, DUMMY$ ' TOTL DL
	    LINE INPUT #1, DUMMY$ ' 7 OR 8 BITS
	     PAR = -1
	     IF VAL(DUMMY$) = 7 THEN
	         GRP = 1 : PAR = 0
	     END IF
	    LINE INPUT #1, LOCAL$ ' LOCAL OR REMOTE
	    LINE INPUT #1, DUMMY$ ' COM PORT
	    LINE INPUT #1, DUMMY$ ' USER BIRTHDATE
	    LINE INPUT #1, BP$ ' USER BAUD RATE
	    IF LEFT$(LOCAL$,3)= "LOC" THEN BP$=LOCAL$
	    Snoop = -1 'PRESUMABLY ALWAYS ON FOR WILDCAT!
	    GOTO WRAP.UP
	END IF



'MAYBE IT'S USING A DORINFOx.DEF FILE
  IF (RIGHT$(MESSAGE.FILE$,3) = "DEF") OR (RIGHT$(MESSAGE.FILE$,3)="def") THEN
1004 OPEN MESSAGE.FILE$ FOR INPUT AS #1
	LINE INPUT #1, DUMMY$ 'RBBS NAME
	LINE INPUT #1, DUMMY$ 'SYSOP FIRST
	LINE INPUT #1, DUMMY$ 'SYSOP LAST
	LINE INPUT #1, DUMMY$ 'COM PORT
	LINE INPUT #1, BP$    'CONNECT
	IF DUMMY$="COM0" OR DUMMY$="" THEN BP$="0"
	LINE INPUT #1, DUMMY$ 'NETWORK TYPE
	LINE INPUT #1, CFN.X$ 'CALLER FIRST NAME
	LINE INPUT #1, CLN.X$ 'CALLER LAST NAME
	LINE INPUT #1, DUMMY$ 'CITY STATE
	LINE INPUT #1, GRAFX$ 'GRAPHICS PRFERENCE
	LINE INPUT #1, DUMMY$ 'SECURITY LEVEL
	LINE INPUT #1, DUMMY$ 'TIME REMAINING
	DOOR.USERS.NAME$= CFN.X$+" "+CLN.X$
	SNOOP = -1 ' SET ON
	GRP = 1
	IF VAL(GRAFX$)=2 THEN GRP=2
'	note ambiguity when using DORINFOx.DEF file about
'	     the user's color preference ... RBBS uses
'	     values of 0,1,& 2 ... while other BBS software
'	     use only 0 (no color) and 1 (color)... with
'	     limited info, we may mistakenly "take away" a
'	     user's color preference ... see later COLORASK
'	     option
	IF VAL(GRAFX$)=1 AND FOR.SURE.RBBS=0 THEN GRP=2
	PAR = -1
	IF INSTR(BP$,"E")>0 THEN PAR = 0
	BP$ = STR$(VAL(BP$))
	GOTO WRAP.UP
  END IF


'NYAH ... IT'S RBBS ....
1005 OPEN "R", 1, MESSAGE.FILE$
	FIELD 1, 128 AS Z$
	GET 1, NODE
	BP$ = MID$(Z$, 60, 4)
	GRP = VAL(MID$(Z$, 53, 2))
	PAR = VAL(MID$(Z$, 42, 2))
	Snoop = VAL(MID$(Z$, 58, 2))
	DOOR.USERS.NAME$ = MID$(Z$, 1, 31)

WRAP.UP:
	FIRST.NAME.END = INSTR(DOOR.USERS.NAME$, " ")
	LAST.NAME.END = INSTR(FIRST.NAME.END + 1, DOOR.USERS.NAME$ + "  ", "  ")
	FIRST$ = LEFT$(DOOR.USERS.NAME$, FIRST.NAME.END - 1)
	LAST$ = MID$(DOOR.USERS.NAME$, FIRST.NAME.END + 1, LAST.NAME.END - (FIRST.NAME.END + 1))
	USER.NAME$ = FIRST$ + " " + LAST$
	CLOSE 1
	IF FORCESPEED = 0 THEN GOTO ENDSTART
	IF VAL(BP$) = 0 THEN GOTO ENDSTART
	BP$ = STR$(FORCESPEED)
ENDSTART:

  I = 0
  LFEED = 1
  IF PAR = -1 THEN
	 PAR$ = ",N,8,1,CS,DS,CD"
  ELSE PAR$ = ",E,7,1,CS,DS,CD"
  END IF
  SYS.OP = 0
  TIME.SAVE = 5
  CR$ = CHR$(13)
  LF$ = CHR$(10)
  CS$ = CHR$(12)
  BK.ARW$ = CHR$(29) + " " + CHR$(29)
  BACK.SP$ = CHR$(8) + " " + CHR$(8)
  COLOR.RESET$ = CHR$(27) + "[00;37;40m"
  COLOR.NORMAL$ = CHR$(27) + "[0m"
  L.OCAL = 0
  IF FIRST$ = "SYSOP" THEN
     SYS.OP = 1
     IF INP(MSR) < 128 THEN L.OCAL = 1
     FIRST$ = SYSOP.FIRST$
     LAST$ = SYSOP.LAST$
     CLOSE 3
  END IF

  IF VAL(BP$) < 1 THEN L.OCAL = 1
  IF COM.PORT$ = "COM0" THEN
	 PRINT "LOCAL WORKSTATION MODE"
	 FOR SL = 1 TO 2000
	 NEXT SL
	 L.OCAL = 1
  END IF
  IF L.OCAL <> 1 THEN
	 OPEN COM.PORT$ + ":" + BP$ + PAR$ FOR RANDOM AS #3
  END IF

  GOSUB Indoor
  P.LINE = 0
  CALL NAM.ADJ(FIRST$)
  CALL NAM.ADJ(LAST$)
  ON.AT$ = TIME$
  IF (Snoop OR L.OCAL = 1) THEN CALL LINE25


'  *******************************************************
'  if you'd like callers, who've logged in as non-color
'  users, to have an opportunity to change their minds
'  (affects only this door and only this time in)  then
'  activate the next two statements, else leave `em comments
'  GOSUB COLORASK
'  GOSUB Indoor
'  *******************************************************

   GOTO BEGIN.YOUR.CODE  ' jumps to where your code starts


'  *******************************************************
'  this is the place that YOUR code, upon normal termination
'  should come -- that is, when user all done, your final
'  statement would be GOTO 60.
'
'  for "abnormal" terminations (out of time, carrier loss,
'  system errors of various sorts) ... see comments later
'  in the code.  In such cases, you'd probably WANT the
'  program to terminate and return to the BBS, but there
'  may be interim results or other info that you haven't
'  stored yet in a file ... if so ... your code to achieve
'  that will be required where indicated.
'  *******************************************************

60 A$ = "Returning to "+RBBS.NAME$
   GOSUB 80

'  *******************************************************
'  if you have a SCOREBOARD.FILE$  ... now is the time to
'  open it and update it
'  *******************************************************

   CLOSE
   END

80 REM **/ Print A$ + Carriage return and linefeed/**
   LN$ = A$
   NORET = 0
   GOSUB OUT.PUT
   row% = 0: col% = 0
   RETURN
100 REM **/ Print A$ through modem /**
    LN$ = A$
    NORET = 1
    GOSUB OUT.PUT
    row% = 0: col% = 0
    RETURN
400 REM **/ Input A$ /*
    GOSUB IN.PUT
    A$ = ARG$
    RETURN
500 REM **/ CLEAR SCREEN
    a$ = chr$(12)
    gosub 80
    RETURN



COLORASK:
  IF GRP=2 THEN RETURN
  IF PAR <> -1 THEN RETURN
  OLDGRP = GRP
  GRP=2
  GOSUB INDOOR
  FC=3
  A$="":GOSUB 80
  A$="Your color selection mode indicates that in the main BBS you prefer plain"
  GOSUB 80
  A$="ASCII text. Color is RECOMMENDED for this game.  You may change to color"
  GOSUB 80
  A$="mode inside this game (affects this game only and this session only)"
  GOSUB 80
  FC=4:
  A$="":GOSUB 80:HIGH=1
  A$="Your system is capable of supporting `color' use IF this paragraph is"
  GOSUB 80:HIGH=1
  A$="a different color than the last  -- or if the question below blinks."
  GOSUB 80
  A$="":GOSUB 80
  FC=7:BLINK=1
  A$="      Use COLOR (Y/N)? " :GOSUB 100 : GOSUB 400
  IF A$="Y" OR A$="y" THEN
    GRP = 2 : RETURN
  END IF
  GRP = OLDGRP
RETURN
BEGIN.YOUR.CODE:




a$= "*********************************************************"
gosub 80
a$= "*********************************************************"
gosub 80
a$= "*********************************************************"
gosub 80
a$= "*********************************************************"
gosub 80
a$= "*********************************************************"
gosub 80
a$= "*********************************************************"
gosub 80
a$= "*********************************************************"
gosub 80
a$= "*********************************************************"
gosub 80
a$= "*********************************************************"
gosub 80
a$= "*********************************************************"
gosub 80
a$= "*********************************************************"
gosub 80
a$= "*********************************************************"
gosub 80
a$= "*********************************************************"
gosub 80
a$= "*********************************************************"
gosub 80
a$ = "Press enter to test:"
gosub 100
gosub 400
GOSUB 500
a$ = "Clear Screen test"
gosub 80
a$ = "Press enter to continue"
gosub 100
gosub 400
gosub 500
row% = 5 : col% = 15
a$ = "Now testing rows and columns (row 5, col 15) hit enter"
gosub 100
gosub 400
row% = 18: col% = 50
a$ = "(row 18, col 50) Hit enter."
gosub 100
gosub 400
row% =2 : col% = 5
a$ = "ROW 2, COL 5.  End of test"
gosub 100
gosub 400


goto 60

'  *********************************************************
'  *********************************************************
'  *********************************************************
'  THIS IS WHERE TO INSERT YOUR CODE FOR DOOR
'  MORE OF SKELETON CODE FOLLOWS
'  *********************************************************
'  *********************************************************
'  *********************************************************
'  *********************************************************

IN.PUT:                                         ' Input ARG$
     ARG$ = ""
     P.LINE = 0
     NOFSX$ = ""
     ENDTIME = FNTI! + (VAL(LOG.OFF$) * 60)

In.put1:                                   ' Idle user check
  IF FNTI! > ENDTIME AND L.OCAL <> 1 THEN
   A$="NO INPUT IN "+LOG.OFF$+" MINUTES! YOU'RE LOGGED OFF!"
   GOSUB 80
   GOTO Exit.door.notime
  END IF

In.put2:
  IF ZX$ = "" THEN GOTO In.put3
  A$ = LEFT$(ZX$, 1)
  IF LEN(ZX$) < 1 THEN
    ZX$ = ""
    GOTO In.put3
  END IF
  ZX$ = RIGHT$(ZX$, LEN(ZX$) - 1)
  GOTO In.put4

In.put3:
  GOSUB Car.test
  A$ = INKEY$

In.put4:
  IF A$ <> "" THEN GOTO In.put5
  IF L.OCAL <> 1 THEN IF NOT (EOF(3)) THEN A$ = INPUT$(1, 3)

In.put5:
  IF A$ = CR$ THEN
   NORET = 0
   LN$ = ""
   GOSUB OUT.PUT
   GOTO In.ret
  END IF
  IF A$ = CHR$(8) OR A$ = CHR$(7) THEN GOTO In.put8
  IF A$ < CHR$(32) OR A$ > CHR$(128) THEN GOTO In.put1
  IF L.OCAL <> 1 AND NOT Snoop THEN GOTO In.put6
  PRINT A$;

In.put6:
  IF L.OCAL = 1 THEN GOTO In.put7
  PRINT #3, A$;

In.put7:
  IF LEN(ARG$) > 254 THEN GOTO In.put1
  ARG$ = ARG$ + A$
  LN$ = A$
  NORET = 1
  GOSUB Car.test
  GOTO In.put1

In.put8:                                       ' Backspace
  IF LEN(ARG$) = 0 THEN GOTO In.put1
  ARG$ = LEFT$(ARG$, LEN(ARG$) - 1)
  PRINT BK.ARW$;
  IF L.OCAL = 1 THEN GOTO In.put1
  PRINT #3, BACK.SP$;
  GOTO In.put1

In.ret:                       'other stack command routine
  ZB = INSTR(ARG$, ";")
  IF ZB = 0 THEN
	GOTO In.ret1
  ELSE ZX$ = ZX$ + MID$(ARG$, ZB + 1)
	ARG$ = LEFT$(ARG$, ZB - 1)
	WHILE INSTR(ZX$, ";") <> 0
	  MID$(ZX$, INSTR(ZX$, ";"), 1) = CHR$(13)
	WEND
	ZX$ = ZX$ + CHR$(13)
  END IF

In.ret1:
  NORET = 0
  RETURN

OUT.PUT:         '** Print LN$ If NORET = 1 then print without carriage return
  IF GRAPHICS = 1 THEN CALL ANSI.COLOR(FC, BC, BLINK, HIGH, L.OCAL)
  IF NORET = 1 THEN
   NORET = 0
   GOTO Out.put1
  END IF
  GOTO Out.put3

Out.put1:                              '** PRINT LN$ W/O C/R
  IF L.OCAL <> 1 AND NOT Snoop THEN GOTO Out.put2
  if row% <> 0 and col% <> 0 then
     locate row%, col%
     PRINT LN$;
   else
     print ln$;
  end if
Out.put2:
  IF L.OCAL = 1 THEN GOTO Chk.line1
  if row% <> 0 and col% <> 0 then
      row$ = str$(row%):row$ = mid$(row$,2,len(row$)-1)
      col$ = str$(col%):col$ = mid$(col$,2,len(col$)-1)
      cursor$ = chr$(27)+ "[" + row$ + ";" + col$ + "H"
      print #3, cursor$;
      PRINT #3, LN$;
    else
      PRINT #3, LN$;
  end if

  IF GRAPHICS = 1 THEN PRINT #3, COLOR.NORMAL$;
  GOSUB Car.test
  GOTO Chk.line1

Out.put3:                              '** PRINT LN$ W/ C/R
  IF L.OCAL <> 1 AND NOT Snoop THEN GOTO Out.put4
  if row% <> 0 and col% <> 0 then
     locate row%, col%
     PRINT LN$
   else
     print ln$
  end if

Out.put4:
  IF L.OCAL = 1 THEN GOTO Chk.line1
  if row% <> 0 and col% <> 0 then
      row$ = str$(row%):row$ = mid$(row$,2,len(row$)-1)
      col$ = str$(col%):col$ = mid$(col$,2,len(col$)-1)
      cursor$ = chr$(27)+ "[" + row$ + ";" + col$ + "H"
      print #3, cursor$;
      PRINT #3, LN$
    else
      PRINT #3, LN$
  end if

  IF GRAPHICS = 1 THEN PRINT #3, COLOR.NORMAL$;
  IF LFEED = 1 THEN PRINT #3, LF$;
  GOSUB Car.test

Chk.line1:
  IF P.LINE >= 23 THEN GOSUB Lin.cntr

Chk.line2:
  GOSUB Check.time2
  GOSUB Check.time1
  NORET = 0
  RETURN

Lin.cntr:                         '** pause if > 23 lns **
  FCSAVE = FC
  BCSAVE = BC
  P.LINE = 0                  '** reset line counter
  FC = 4
  BC = 7
  LN$ = "[ENTER] to continue, [E] to end "
  NORET = 1
  GOSUB OUT.PUT
  GOSUB IN.PUT
  NOFSX$ = ARG$
  IF INSTR(NOFSX$, "e") <> 0 OR INSTR(NOFSX$, "E") <> 0 THEN NOFSX$ = "Q"
  P.LINE = 0
  FC = FCSAVE
  BC = BCSAVE
  RETURN

Car.test:                        '** Check carrier drop
  IF L.OCAL = 1 THEN RETURN
  IF INP(MSR) >= 128 THEN RETURN
  IF Snoop THEN PRINT "(**CARRIER DROPPED**)"
  RETURN Car.drop

Car.drop:
  CLOSE
' INSERT CODE (IF ANY NEEDED) TO WRAP-UP BEFORE RETURNING
' TO SYSTEM AFTER CARRIER DROP
  END

Fast.exit:                 '** Close and return to system
  CLOSE
  OUT MCR, INP(MCR) OR 1
  SYSTEM

Exit.door:
     END
Exit.door.notime:          'we come here if time expired
                           'insert code desired to
                           'gracefully terminate user
	END

Err.routine:                       '** Error routines
'DEVICE I/O ERROR
     IF ERR = 57 THEN RESUME

'check for errors in reading door's DEF file or BBS-specific info
'  (MESSAGES, DORINFOx.DEF, CALLINFO.BBS, PCBOARD.SYS)
IF ERR = 53 AND ERL = 1001 THEN PRINT"ERROR WITH DOOR's DEF FILE":RESUME FAST.EXIT
IF ERL = 1002 THEN PRINT"ERROR WITH PCBoard.SYS FILE: "+MESSAGE.FILE$: RESUME FAST.EXIT
IF ERL = 1003 THEN PRINT"ERROR WITH WILDCAT'S CALLINFO.BBS FILE "+MESSAGE.FILE$: RESUME FAST.EXIT
IF ERL = 1004 THEN PRINT"ERRROR WITH DORINFOx.DEF FILE "+MESSAGE.FILE$: RESUME FAST.EXIT
IF ERL = 1005 THEN PRINT"ERRROR WITH RBBS's MESSAGE FILE "+MESSAGE.FILE$: RESUME FAST.EXIT

'  many of the most likely errors listed below -- author reponsibility
'  to trap and or take appropriate action -- all such errors in this
'  skeleton code result in abrupt termination of program and a return
'  to the BBS
'
' ERR = 5 = ILLEGAL FUNCTION CALL
' ERR = 6 = OVERFLOW
' ERR = 9 = SUBSCRIPT OUT OF RANGE
' ERR =11 = DIVISION BY ZERO
' ERR =24 = DEVICE TIMEOUT
' ERR =25 = DEVICE FAULT
' ERR =27 = OUT OF PAPER
' ERR =52 = BAD FILE NAME OR NUMBER
' ERR =53 = FILE NOT FOUND
' ERR =54 = BAD FILE MODE
' ERR =55 = FILE ALREADY OPEN
' ERR =57 = DEVICE I/O ERROR
' ERR =58 = FILE ALREADY EXISTS
' ERR =70 = PERMISSION DENIED
' ERR =71 = DISK NOT READY
' ERR =75 = PATH/FILE ACCESS ERROR
' ERR =76 = PATH NOT FOUND

Write.err:
  LN$ = "Error >" + STR$(ERR) + " File >" + DOOR.NAME$ + " Date >" + DATE$ + " " + TIME$
  GOSUB OUT.PUT
  CLOSE
  OPEN "ERRORS.DOR" FOR APPEND AS #4
  PRINT #4, LN$
  CLOSE #4
  GOTO Exit.door

Check.time1:
  WARNING = TIME.OFF - 180
  IF FNTI! > WARNING AND T.IMER = 1 THEN
	IF INT((TIME.OFF - FNTI!) / 60) < TIME.SAVE THEN
	   WARNING = WARNING + 60
	   LN$ = "** YOU HAVE" + STR$(INT((TIME.OFF - FNTI!) / 60)) + " MINUTES REMAINING!! **"
	   IF L.OCAL <> 1 THEN PRINT #3, CHR$(7)
	   GOSUB OUT.PUT
	   TIME.SAVE = INT((TIME.OFF - FNTI!) / 60)
	   T.IMER = 0
	   RETURN
	END IF
  END IF
  RETURN

Check.time2:
  IF FNTI! > TIME.OFF THEN
	LN$ = "TIME LIMIT EXCEEDED!"
	GOSUB OUT.PUT
	RETURN Exit.door.notime
  END IF
  RETURN

Chatter:                           '*** F-10 CHAT MODE ***
     SAVETIME = TIME.OFF - FNTI!
     LINE.SAVE$ = LN$
     NORET = 0
     LN$ = ""
     GOSUB OUT.PUT
     GOSUB OUT.PUT
     PRINT "SysOp - Hit ESC to exit chat mode"
     LN$ = "Yo!  This is " + SYSOP.FIRST$ + ","
     GOSUB OUT.PUT

Remote:
  IF LOC(3) = 0 THEN GOTO Local.test
  Chat$ = INPUT$(1, 3)
  IF ASC(Chat$) = 8 THEN
	PRINT BK.ARW$;
	PRINT #3, BACK.SP$;
  ELSEIF ASC(Chat$) = 27 THEN
	GOTO Local.inp
  ELSE
	PRINT Chat$;
	PRINT #3, Chat$;
  END IF
  IF ASC(Chat$) = 13 THEN PRINT #3, CHR$(10);
  GOTO Remote

Local.test:
  GOSUB Car.test
  Chat$ = INKEY$
  IF LEN(Chat$) = 0 THEN GOTO Remote

Local.inp:
  IF ASC(Chat$) = 27 THEN GOTO Chat.end
  IF ASC(Chat$) = 8 THEN
	PRINT BK.ARW$;
	PRINT #3, BACK.SP$;
  ELSE
	PRINT Chat$;
	PRINT #3, Chat$;
  END IF
  IF ASC(Chat$) = 13 THEN PRINT #3, CHR$(10);
  GOTO Remote

Chat.end:
     TIME.OFF = FNTI! + SAVETIME
     WARNING = TIME.OFF - (3 * 60)
     ENDTIME = FNTI! + 240
     LN$ = ""
     GOSUB OUT.PUT
     ARG$ = ""
     LN$ = "Chat mode terminated"
     GOSUB OUT.PUT
     LN$ = LINE.SAVE$
     GOSUB OUT.PUT
     RETURN

Indoor:
      EC = 0
	  TIME.OFF = FNTI! + (NM.TIME * 60)
	  IF GRP = 2 THEN GRAPHICS = 1 ELSE GRAPHICS = 0
      NO.MONITOR = 1
      RETURN


Snoop:
  IF L.OCAL = 1 THEN RETURN
  IF NOT Snoop THEN
	LOCATE 24, 1, 0
	PRINT "SNOOP ON"
	CALL LINE25
	Snoop = NOT Snoop
  ELSE LOCATE , , 0
	Snoop = FALSE
	CLS
  END IF
  RETURN

Forceoff:
 TIME.NOW.LEFT = INT((TIME.OFF - FNTI!)/60)
 PRINT "Minutes till user forced off? [";TIME.NOW.LEFT;"] ";
 INPUT MIN.F.O$
 IF MIN.F.O$ = "" THEN RETURN
 FORCE.OFF = VAL(MIN.F.O$)
 A$ = "YOU MUST BE OFF in" + STR$(FORCE.OFF) + " minutes!"
 GOSUB 80
 A$ = "Please complete what you are doing within that time"
 GOSUB 80
 TIME.OFF = FNTI! + (FORCE.OFF * 60)
 WARNING = TIME.OFF - (3 * 60)
 IF TIME.SAVE < 5 THEN TIME.SAVE = 5
 A$=""
 GOSUB 80
 ARG$=""
 ZX$=""
 RETURN

SUB ANSI.COLOR (FC, BC, BLINK, HIGH, L.OCAL) STATIC
  IF FC = BC THEN
    BC = 0
    IF FC = 0 THEN FC = 7
  END IF
  AC$ = CHR$(27) + "[3"

'  set local colors
  LFC = FC
  IF HIGH = 1 THEN LFC = LFC + 8
  IF BLINK = 1 THEN LFC = LFC + 16
  COLOR C.OLOR(LFC), C.OLOR(BC)

' see if running locally too
  IF L.OCAL = 1 THEN
	BLINK = 0
	HIGH = 0
	EXIT SUB
  END IF

  REMOTE.ANSI$ = AC$ + MID$(STR$(FC), 2, 1) + ";4" + MID$(STR$(BC), 2, 1)    'USER ROUTINE
  IF BLINK = 1 THEN REMOTE.ANSI$ = REMOTE.ANSI$ + ";5"
  IF HIGH = 1 THEN REMOTE.ANSI$ = REMOTE.ANSI$ + ";1"
  REMOTE.ANSI$ = REMOTE.ANSI$ + "m"
  PRINT #3, REMOTE.ANSI$;
  BLINK = 0
  HIGH = 0
  END SUB

   SUB LINE25 STATIC
   SHARED FIRST$, LAST$, DOOR.NAME$, RD$, ON.AT$
   COLOR 11, 1
   LOCATE 25, 1
   PRINT FIRST$ + " " + LAST$; TAB(32); DOOR.NAME$; TAB(55); "Node: " + RD$; TAB(70); ON.AT$ + " "
   COLOR 7, 0
   END SUB

   SUB NAM.ADJ (NAME$) STATIC
   AX = 0
   FOR LX = 1 TO LEN(NAME$)
    BX = ASC(MID$(NAME$, LX, 1))
    IF AX = 0 AND BX > 96 AND BX < 123 THEN
	   MID$(NAME$, LX, 1) = CHR$(BX - 32)
    ELSEIF AX = 1 AND BX > 64 AND BX < 91 THEN
	   MID$(NAME$, LX, 1) = CHR$(BX + 32)
    END IF
    AX = 1
    IF BX< 65 OR (BX >90 AND BX< 96) OR BX> 123 THEN AX = 0
   NEXT
   END SUB
