DECLARE FUNCTION ColorChk ()
DECLARE FUNCTION GetString$ (LeftCol!, Row%, StrLen%, ForeColor%, BackColor%)
DECLARE FUNCTION MakeMenu% (Choice$(), NumOfChoices%, Justify$, LeftColumn!, RightColumn!, Row%, FG%, BG%, HFG%, HBG%)
DECLARE SUB Banner (St$, Row%)
DECLARE SUB Center (St$, Row%)
DECLARE SUB MakeWindow (TopRow!, LeftCol!, BotRow!, RightCol!, ForeColor%, BackColor%, WindowType%, FrameType%, ShadowColor%, ExplodeType%, Label$)
DECLARE SUB OffCenter (St$, Row%, LeftCol!, RightCol!)

SUB Banner (St$, Row%) STATIC


	'=== Check to see if this is the first time Banner has been called. ===

	Temp$ = ""
	IF NOT (BannerFlag) THEN
		BannerFlag = -1
		Text$ = St$
	END IF

   
	'=== Move each character in the banner string one space to the left ===

	FOR N = 1 TO LEN(Text$) - 1
		Temp$ = Temp$ + MID$(Text$, N + 1, 1)
	NEXT N

   
	'=== Set the last character in Temp$ to the first character of the string ===

	Temp$ = Temp$ + LEFT$(Text$, 1)

   
	'=== Determine the column to display the new string on, centered ===
   
	Text$ = Temp$
	X% = INT((80 - (LEN(Text$))) / 2)


	'=== Print the newly adjusted string ===

	LOCATE Row%, X%
	PRINT Text$

END SUB

SUB Center (St$, Row%)

'====================== TEXT CENTERING SUB-PROGRAM =======================


'=== Calculate X-Coordinate for Locate ===

X% = INT((80 - (LEN(St$))) / 2)


'=== Locate the text string ===

LOCATE Row%, X%: PRINT St$

END SUB

FUNCTION ColorChk


	'=== Set segment to video adapter ===

	DEF SEG = 0

   
	'=== PEEK at value stored at video adapter address ===

	ADAPTER = PEEK(&H463)


	'=== Set ColorChk to True or False based on value at hex &H463 ===

	IF ADAPTER = &HB4 THEN
		ColorChk = 0  '=== Mono (False/Zero) ===
	ELSE
		ColorChk = 1  '=== Color (True/Non-Zero) ===
	END IF

END FUNCTION

FUNCTION GetString$ (LeftCol, Row%, StrLen%, ForeColor%, BackColor%)

'== This function returns a user-entered string.  It's value is that you can
'== limit the string length as they type, not possible with INPUT.  You can
'== also modify the CASE statement to allow only certain types of characters
'== to be entered.

'== Set a couple variables

Enter$ = CHR$(13)
Esc$ = CHR$(27)
BackSpace$ = CHR$(8)
ErrorTone$ = "L60 N1 N0 N1"

'== Clear variable that holds keystroke

Key$ = ""
CharCount% = 0
COLOR ForeColor%, BackColor%
LOCATE Row%, LeftCol + 1, 1

'== Read keystrokes until ENTER is pressed, signalling completion.

WHILE Key$ <> Enter$

	Key$ = ""
	WHILE Key$ = ""
		Key$ = INKEY$
	WEND

	'== Decide what to do with the returned key

	SELECT CASE Key$

		'=== The CASE statement below is what checks for allowable characters.
		'=== If you wish to change the set of allowable characters, change the
		'=== conditions of the CASE statement.

		CASE " " TO ""    '== ASCII 32 to 254 - typable characters
			IF CharCount% < StrLen% THEN
				St$ = St$ + Key$
				CharCount% = CharCount% + 1
				LOCATE Row%, LeftCol + CharCount%, 1
				PRINT Key$
				LOCATE Row%, LeftCol + CharCount% + 1, 1
			ELSE
				PLAY ErrorTone$
			END IF

		CASE BackSpace$   '== Allow corrections via the backspace key
			IF CharCount% > 0 THEN
				St$ = LEFT$(St$, LEN(St$) - 1)
				LOCATE Row%, LeftCol + CharCount%, 1
				PRINT " "
				CharCount% = CharCount% - 1
				LOCATE Row%, LeftCol + CharCount% + 1, 1
			ELSE
				PLAY ErrorTone$
			END IF

		CASE Enter$      '== Finished entering string
			GetString$ = St$

		CASE Esc$        '== User hit ESCape - abort entry - exit function
			GetString$ = Esc$
			EXIT FUNCTION

		CASE ELSE        '== Unacceptable key was hit
			PLAY ErrorTone$

	END SELECT     '== CASE Key$

WEND    '== WHILE Key$ <> Enter$

END FUNCTION

FUNCTION MakeMenu% (Choice$(), NumOfChoices%, Justify$, LeftColumn, RightColumn, Row%, FG%, BG%, HFG%, HBG%)


'=== Set local variables - extended scan codes for keypad keys ===

Up$ = CHR$(0) + CHR$(72)
Down$ = CHR$(0) + CHR$(80)
Enter$ = CHR$(13)
Home$ = CHR$(0) + CHR$(71)
End$ = CHR$(0) + CHR$(79)
PgUp$ = CHR$(0) + CHR$(73)
PgDn$ = CHR$(0) + CHR$(81)
ErrorTone$ = "L60 N1 N0 N1"

'=== Set type of justification to uppercase ===

LET Justify$ = UCASE$(Justify$)


'=== Check for out-of-bounds parameters.  If any are out of range, quit the function ===

IF NumOfChoices% < 2 OR NumOfChoices% > 23 THEN EXIT FUNCTION
IF Justify$ <> "C" AND Justify$ <> "L" AND Justify$ <> "R" THEN EXIT FUNCTION
IF LeftColumn < 1 OR RightColumn > 80 THEN EXIT FUNCTION
IF Row% < 1 OR Row% > 25 THEN EXIT FUNCTION


'=== Calculate length of longest menu choice and store value in ChoiceLen% ===

ChoiceLen% = 0
FOR X% = 1 TO NumOfChoices%
	IF LEN(Choice$(X%)) > ChoiceLen% THEN
		ChoiceLen% = LEN(Choice$(X%))
	END IF
NEXT X%
Col = (((RightColumn - LeftColumn - 1) - ChoiceLen%) / 2) + LeftColumn

'=== Print menu choices to screen based on the type of
'=== Justification selected (Center, Left, Right).

COLOR FG%, BG%
SELECT CASE Justify$
	CASE "C"
		FOR X% = 1 TO NumOfChoices%
			S$ = Choice$(X%): CALL OffCenter(S$, (Row% - 1 + X%), LeftColumn, RightColumn)
		NEXT X%
	CASE "R"
		FOR X% = 1 TO NumOfChoices%
			LOCATE (Row% - 1) + X%, (RightColumn - LEN(Choice$(X%))): PRINT Choice$(X%)
		NEXT X%
	CASE "L"
		FOR X% = 1 TO NumOfChoices%
			LOCATE (Row% - 1) + X%, LeftColumn: PRINT Choice$(X%)
		NEXT X%
END SELECT


'=== highlight the first choice ===

CurrentLocation% = 1
COLOR HFG%, HBG%
LOCATE Row%, Col - 1: PRINT SPACE$(ChoiceLen% + 2)
SELECT CASE Justify$
	CASE "C"
		S$ = Choice$(CurrentLocation%): CALL OffCenter(S$, (Row% - 1 + CurrentLocation%), LeftColumn, RightColumn)
	CASE "R"
		LOCATE (Row% - 1) + CurrentLocation%, (RightColumn - LEN(Choice$(CurrentLocation%))): PRINT Choice$(CurrentLocation%)
	CASE "L"
		LOCATE (Row% - 1) + CurrentLocation%, LeftColumn: PRINT Choice$(CurrentLocation%)
END SELECT


'=== Read up and down arrow keys and change the highlighted entry appropriately

ExitCode = False
WHILE ExitCode = False
	Key$ = ""
	WHILE Key$ = ""
		LET Key$ = UCASE$(INKEY$)
	WEND
   
	SELECT CASE Key$

		CASE Up$, Down$, Home$, End$, PgUp$, PgDn$


			'=== Restore old highlighted choice to normal colors ===
		 
			COLOR FG%, BG%
			LOCATE (Row% - 1) + CurrentLocation%, Col - 1: PRINT SPACE$(ChoiceLen% + 2)
			SELECT CASE Justify$
				CASE "C"
					S$ = Choice$(CurrentLocation%): CALL OffCenter(S$, (Row% - 1 + CurrentLocation%), LeftColumn, RightColumn)
				CASE "R"
					LOCATE (Row% - 1) + CurrentLocation%, (RightColumn - LEN(Choice$(CurrentLocation%))): PRINT Choice$(CurrentLocation%)
				CASE "L"
					LOCATE (Row% - 1) + CurrentLocation%, LeftColumn: PRINT Choice$(CurrentLocation%)
			END SELECT

		CASE ELSE

			'Nuthin!

	END SELECT
   
	SELECT CASE Key$

		CASE Up$
		 
		   
			'=== Set new CurrentLocation% ===

			IF CurrentLocation% = 1 THEN
				CurrentLocation% = NumOfChoices%
			ELSE
				CurrentLocation% = CurrentLocation% - 1
			END IF
		   
		CASE Down$
		
		   
			'=== Set New CurrentLocation% ===

			IF CurrentLocation% = NumOfChoices% THEN
				CurrentLocation% = 1
			ELSE
				CurrentLocation% = CurrentLocation% + 1
			END IF

		CASE Enter$

		   
			'=== Set MakeMenu to highlighted selection and exit ===

			MakeMenu% = CurrentLocation%


			'=== Instead of using ExitCode to beak out of this, we have to use
			'=== EXIT FUNCTION, or it never quits.

			EXIT FUNCTION
	   
		CASE Home$, PgUp$
		   
		   
			'=== Set New CurrentLocation% ===

			CurrentLocation% = 1

		CASE End$, PgDn$

		   
			'=== Set New CurrentLocation% ===
										   
			CurrentLocation% = NumOfChoices%

		CASE ELSE

		   
			'=== Play Error Tone - change this around if your don't like it ===

			PLAY ErrorTone$

	END SELECT
   
	SELECT CASE Key$
	   
		CASE Up$, Down$, Home$, End$, PgUp$, PgDn$

			'=== HighLight new choice ===
	  
			COLOR HFG%, HBG%
			LOCATE (Row% - 1) + CurrentLocation%, Col - 1: PRINT SPACE$(ChoiceLen% + 2)
			SELECT CASE Justify$
				CASE "C"
					S$ = Choice$(CurrentLocation%): CALL OffCenter(S$, (Row% - 1 + CurrentLocation%), LeftColumn, RightColumn)
				CASE "R"
					LOCATE (Row% - 1) + CurrentLocation%, (RightColumn - LEN(Choice$(CurrentLocation%))): PRINT Choice$(CurrentLocation%)
				CASE "L"
					LOCATE (Row% - 1) + CurrentLocation%, LeftColumn: PRINT Choice$(CurrentLocation%)
			END SELECT

		CASE ELSE

			'Nuthin!

	END SELECT

WEND

END FUNCTION

SUB MakeWindow (TopRow!, LeftCol!, BotRow!, RightCol!, ForeColor%, BackColor%, WindowType%, FrameType%, ShadowColor%, ExplodeType%, Label$)


'====================== MAKEWINDOW SUB-PROGRAM =====================


'=== Setup Lines$ as a dynamic array that can REDimensioned ========

'$DYNAMIC
DIM Line$(24)
Part1 = 0: Part2 = 0: NumLines = 0


'=== Check all passed values for validity and set defaults =========

NumLines = 0

IF TopRow < 1 THEN TopRow = 1: IF TopRow > 22 THEN TopRow = 22
IF BotRow < 3 THEN BotRow = 3: IF BotRow > 23 THEN BotRow = 23
IF RightCol < 3 THEN RightCol = 3: IF RightCol > 80 THEN RightCol = 80
IF LeftCol < 1 THEN LeftCol = 1: IF LeftCol > 80 THEN LeftCol = 80

IF ForeColor% < 0 OR ForeColor% > 15 THEN ForeColor% = 7
IF BackColor% < 0 OR BackColor% > 7 THEN BackColor% = 0

IF WindowType% < 0 OR WindowType% > 9 THEN WindowType% = 0
IF FrameType% < 0 OR FrameType% > 5 THEN FrameType% = 0
IF ShadowColor% > 15 THEN ShadowColor% = 0
IF ExplodeType% < 0 OR ExplodeType% > 3 THEN ExplodeType% = 0

IF LEN(Label$) > ((RightCol - LeftCol) - 4) THEN Label$ = ""


'=== Setup Graphics characters to use based on FrameType% ===========

SELECT CASE FrameType%

	CASE 0  '=== All lines SINGLE

		URC$ = CHR$(191): ULC$ = CHR$(218): LLC$ = CHR$(192): LRC$ = CHR$(217)
		VER$ = CHR$(179): HOR$ = CHR$(196)
		VTL$ = CHR$(195): VTR$ = CHR$(180)
		HTT$ = CHR$(194): HTB$ = CHR$(193)
		CRS$ = CHR$(197): BLK$ = CHR$(219)
		LBL$ = CHR$(180): LBR$ = CHR$(195)

	CASE 1  '=== All lines DOUBLE

		URC$ = CHR$(187): ULC$ = CHR$(201): LLC$ = CHR$(200): LRC$ = CHR$(188)
		VER$ = CHR$(186): HOR$ = CHR$(205)
		VTL$ = CHR$(204): VTR$ = CHR$(185)
		HTT$ = CHR$(203): HTB$ = CHR$(202)
		CRS$ = CHR$(206): BLK$ = CHR$(219)
		LBL$ = CHR$(181): LBR$ = CHR$(198)

	CASE 2  '=== Horizontals SINGLE / Verticals DOUBLE

		URC$ = CHR$(183): ULC$ = CHR$(214): LLC$ = CHR$(211): LRC$ = CHR$(189)
		VER$ = CHR$(186): HOR$ = CHR$(196)
		VTL$ = CHR$(199): VTR$ = CHR$(182)
		HTT$ = CHR$(210): HTB$ = CHR$(208)
		CRS$ = CHR$(215): BLK$ = CHR$(219)
		LBL$ = CHR$(180): LBR$ = CHR$(195)

	CASE 3  '=== Horizontals DOUBLE / Verticals SINGLE

		URC$ = CHR$(184): ULC$ = CHR$(213): LLC$ = CHR$(212): LRC$ = CHR$(190)
		VER$ = CHR$(179): HOR$ = CHR$(205)
		VTL$ = CHR$(198): VTR$ = CHR$(181)
		HTT$ = CHR$(209): HTB$ = CHR$(207)
		CRS$ = CHR$(216): BLK$ = CHR$(219)
		LBL$ = CHR$(181): LBR$ = CHR$(198)

	CASE 4  '=== Outside lines DOUBLE / Inside lines SINGLE

		URC$ = CHR$(187): ULC$ = CHR$(201): LLC$ = CHR$(200): LRC$ = CHR$(188)
		VER$ = CHR$(186): VER1$ = CHR$(179): HOR$ = CHR$(205): HOR1$ = CHR$(196)
		VTL$ = CHR$(199): VTR$ = CHR$(182)
		HTT$ = CHR$(209): HTT1$ = CHR$(194): HTB$ = CHR$(207): HTB1$ = CHR$(193)
		CRS$ = CHR$(197): BLK$ = CHR$(219)
		LBL$ = CHR$(181): LBR$ = CHR$(198)

	CASE 5  '=== Outside lines SINGLE / Inside Lines DOUBLE

		URC$ = CHR$(191): ULC$ = CHR$(218): LLC$ = CHR$(192): LRC$ = CHR$(217)
		VER$ = CHR$(179): VER1$ = CHR$(186): HOR$ = CHR$(196): HOR1$ = CHR$(205)
		VTL$ = CHR$(198): VTR$ = CHR$(181)
		HTT$ = CHR$(210): HTT1$ = CHR$(203): HTB$ = CHR$(208): HTB1$ = CHR$(202)
		CRS$ = CHR$(206): BLK$ = CHR$(219)
		LBL$ = CHR$(180): LBR$ = CHR$(195)

	CASE ELSE

		'=== Shouldn't be an "else" !

END SELECT


'=== Calculate the number of lines to be printed ===

NumLines = (BotRow - TopRow) + 1
REDIM Line$(NumLines)


'=== Determine ExplodeStep% for explode loop based on ExplodeType% ==========

SELECT CASE ExplodeType%

	CASE 0  '=== Exploding Windows OFF ===

		ExplodeStep% = 0

	CASE 1  '=== Explode ratio automatic ===

		ExplodeStep% = INT((RightCol - LeftCol) / (BotRow - TopRow))

	CASE 2  '=== Explode ratio biased toward HORIZONTAL ===

		ExplodeStep% = 3

	CASE 3  '=== Explode ratio biased toward VERTICAL ===

		ExplodeStep% = 1

END SELECT


'=== Construct the Window strings based on WindowType% ===

SELECT CASE WindowType%

	CASE 0  '=== Regular box, no extra lines ===

		Line$(1) = ULC$ + STRING$((RightCol - LeftCol) - 1, HOR$) + URC$
		FOR X = 2 TO NumLines - 1
			Line$(X) = VER$ + SPACE$((RightCol - LeftCol) - 1) + VER$
		NEXT X
		Line$(NumLines) = LLC$ + STRING$((RightCol - LeftCol) - 1, HOR$) + LRC$

	CASE 1  '=== Box with extra internal line at top and bottom ===

		Line$(1) = ULC$ + STRING$((RightCol - LeftCol) - 1, HOR$) + URC$
		Line$(2) = VER$ + SPACE$((RightCol - LeftCol) - 1) + VER$
		IF FrameType% = 4 OR FrameType% = 5 THEN
			TempHOR$ = HOR$
			HOR$ = HOR1$
		END IF
		Line$(3) = VTL$ + STRING$((RightCol - LeftCol) - 1, HOR$) + VTR$
		FOR X = 4 TO NumLines - 3
			Line$(X) = VER$ + SPACE$((RightCol - LeftCol) - 1) + VER$
		NEXT X
		Line$(NumLines - 2) = VTL$ + STRING$((RightCol - LeftCol) - 1, HOR$) + VTR$
		Line$(NumLines - 1) = VER$ + SPACE$((RightCol - LeftCol) - 1) + VER$
		IF FrameType% = 4 OR FrameType% = 5 THEN
			HOR$ = TempHOR$
		END IF
		Line$(NumLines) = LLC$ + STRING$((RightCol - LeftCol) - 1, HOR$) + LRC$

	CASE 2  '=== Box with extra internal line at top ===

		Line$(1) = ULC$ + STRING$((RightCol - LeftCol) - 1, HOR$) + URC$
		Line$(2) = VER$ + SPACE$((RightCol - LeftCol) - 1) + VER$
		IF FrameType% = 4 OR FrameType% = 5 THEN
			TempHOR$ = HOR$
			HOR$ = HOR1$
		END IF
		Line$(3) = VTL$ + STRING$((RightCol - LeftCol) - 1, HOR$) + VTR$
		FOR X = 4 TO NumLines - 1
			Line$(X) = VER$ + SPACE$((RightCol - LeftCol) - 1) + VER$
		NEXT X
		IF FrameType% = 4 OR FrameType% = 5 THEN
			HOR$ = TempHOR$
		END IF
		Line$(NumLines) = LLC$ + STRING$((RightCol - LeftCol) - 1, HOR$) + LRC$

	CASE 3  '=== Box with extra internal line at bottom ===

		Line$(1) = ULC$ + STRING$((RightCol - LeftCol) - 1, HOR$) + URC$
		FOR X = 2 TO NumLines - 3
			Line$(X) = VER$ + SPACE$((RightCol - LeftCol) - 1) + VER$
		NEXT X
		IF FrameType% = 4 OR FrameType% = 5 THEN
			TempHOR$ = HOR$
			HOR$ = HOR1$
		END IF
		Line$(NumLines - 2) = VTL$ + STRING$((RightCol - LeftCol) - 1, HOR$) + VTR$
		Line$(NumLines - 1) = VER$ + SPACE$((RightCol - LeftCol) - 1) + VER$
		IF FrameType% = 4 OR FrameType% = 5 THEN
			HOR$ = TempHOR$
		END IF
		Line$(NumLines) = LLC$ + STRING$((RightCol - LeftCol) - 1, HOR$) + LRC$

	CASE 4  '=== Box with vertical line down the center ===

		Part1 = ((RightCol - LeftCol) - 1) / 2
		IF INT(Part1) = Part1 THEN
			Part2 = Part1 - 1
		ELSE
			Part1 = INT(Part1)
			Part2 = Part1
		END IF
		Line$(1) = ULC$ + STRING$(Part1, HOR$) + HTT$ + STRING$(Part2, HOR$) + URC$
		IF FrameType% <> 4 AND FrameType% <> 5 THEN
			VER1$ = VER$
		END IF
		FOR X = 2 TO NumLines - 1
			Line$(X) = VER$ + SPACE$(Part1) + VER1$ + SPACE$(Part2) + VER$
		NEXT X
		Line$(NumLines) = LLC$ + STRING$(Part1, HOR$) + HTB$ + STRING$(Part2, HOR$) + LRC$

	CASE 5  '=== Box with horizontal line down the center ===

		TopHalf = INT(NumLines / 2)
		Line$(1) = ULC$ + STRING$((RightCol - LeftCol) - 1, HOR$) + URC$
		FOR X = 2 TO TopHalf
			Line$(X) = VER$ + SPACE$((RightCol - LeftCol) - 1) + VER$
		NEXT X
		IF FrameType% = 4 OR FrameType% = 5 THEN
			TempHOR$ = HOR$
			HOR$ = HOR1$
		END IF
		Line$(TopHalf + 1) = VTL$ + STRING$((RightCol - LeftCol) - 1, HOR$) + VTR$
		IF FrameType% = 4 OR FrameType% = 5 THEN
			HOR$ = TempHOR$
		END IF
		FOR X = TopHalf + 2 TO NumLines - 1
			Line$(X) = VER$ + SPACE$((RightCol - LeftCol) - 1) + VER$
		NEXT X
		Line$(NumLines) = LLC$ + STRING$((RightCol - LeftCol) - 1, HOR$) + LRC$

	CASE 6  '=== Box cross-divided into four sections ===

		TopHalf = INT(NumLines / 2): Part1 = ((RightCol - LeftCol) - 1) / 2
		IF INT(Part1) = Part1 THEN
			Part2 = Part1 - 1
		ELSE
			Part1 = INT(Part1): Part2 = Part1
		END IF
		Line$(1) = ULC$ + STRING$(Part1, HOR$) + HTT$ + STRING$(Part2, HOR$) + URC$
		IF FrameType% <> 4 AND FrameType% <> 5 THEN VER1$ = VER$
		FOR X = 2 TO TopHalf
			Line$(X) = VER$ + SPACE$(Part1) + VER1$ + SPACE$(Part2) + VER$
		NEXT X
		IF FrameType% = 4 OR FrameType% = 5 THEN
			TempHOR$ = HOR$: HOR$ = HOR1$
		END IF
		Line$(TopHalf + 1) = VTL$ + STRING$(Part1, HOR$) + CRS$ + STRING$(Part2, HOR$) + VTR$
		IF FrameType% = 4 OR FrameType% = 5 THEN HOR$ = TempHOR$
		FOR X = TopHalf + 2 TO NumLines - 1
			Line$(X) = VER$ + SPACE$(Part1) + VER1$ + SPACE$(Part2) + VER$
		NEXT X
		Line$(NumLines) = LLC$ + STRING$(Part1, HOR$) + HTB$ + STRING$(Part2, HOR$) + LRC$

	CASE 7  '=== Box with extra internal line at top and vertical dividing line

		Part1 = ((RightCol - LeftCol) - 1) / 2
		IF INT(Part1) = Part1 THEN
			Part2 = Part1 - 1
		ELSE
			Part1 = INT(Part1)
			Part2 = Part1
		END IF
		Line$(1) = ULC$ + STRING$((RightCol - LeftCol) - 1, HOR$) + URC$
		Line$(2) = VER$ + SPACE$((RightCol - LeftCol) - 1) + VER$
		IF FrameType% <> 4 AND FrameType% <> 5 THEN
			HTT1$ = HTT$
			VER1$ = VER$
			HOR1$ = HOR$
		END IF
		Line$(3) = VTL$ + STRING$(Part1, HOR1$) + HTT1$ + STRING$(Part2, HOR1$) + VTR$
		FOR X = 4 TO NumLines - 1
			Line$(X) = VER$ + SPACE$(Part1) + VER1$ + SPACE$(Part2) + VER$
		NEXT X
		Line$(NumLines) = LLC$ + STRING$(Part1, HOR$) + HTB$ + STRING$(Part2, HOR$) + LRC$

	CASE 8  '=== Box with extra internalline at bottom and vertical dividing line

		Part1 = ((RightCol - LeftCol) - 1) / 2
		IF INT(Part1) = Part1 THEN
			Part2 = Part1 - 1
		ELSE
			Part1 = INT(Part1)
			Part2 = Part1
		END IF
		Line$(1) = ULC$ + STRING$(Part1, HOR$) + HTT$ + STRING$(Part2, HOR$) + URC$
		IF FrameType% <> 4 AND FrameType% <> 5 THEN
			HTB1$ = HTB$
			VER1$ = VER$
			HOR1$ = HOR$
		END IF
		FOR X = 2 TO NumLines - 3
			Line$(X) = VER$ + SPACE$(Part1) + VER1$ + SPACE$(Part2) + VER$
		NEXT X
		Line$(NumLines - 2) = VTL$ + STRING$(Part1, HOR1$) + HTB1$ + STRING$(Part2, HOR1$) + VTR$
		Line$(NumLines - 1) = VER$ + SPACE$((RightCol - LeftCol) - 1) + VER$
		Line$(NumLines) = LLC$ + STRING$((RightCol - LeftCol) - 1, HOR$) + LRC$

	CASE 9  '===Box with extra internal lines at top and bottom, with dividing line

		Part1 = ((RightCol - LeftCol) - 1) / 2
		IF INT(Part1) = Part1 THEN
			Part2 = Part1 - 1
		ELSE
			Part1 = INT(Part1)
			Part2 = Part1
		END IF
		Line$(1) = ULC$ + STRING$((RightCol - LeftCol) - 1, HOR$) + URC$
		Line$(2) = VER$ + SPACE$((RightCol - LeftCol) - 1) + VER$
		IF FrameType% <> 4 AND FrameType% <> 5 THEN
			HTT1$ = HTT$
			HTB1$ = HTB$
			VER1$ = VER$
			HOR1$ = HOR$
		END IF
		Line$(3) = VTL$ + STRING$(Part1, HOR1$) + HTT1$ + STRING$(Part2, HOR1$) + VTR$
		FOR X = 4 TO NumLines - 3
			Line$(X) = VER$ + SPACE$(Part1) + VER1$ + SPACE$(Part2) + VER$
		NEXT X
		Line$(NumLines - 2) = VTL$ + STRING$(Part1, HOR1$) + HTB1$ + STRING$(Part2, HOR1$) + VTR$
		Line$(NumLines - 1) = VER$ + SPACE$((RightCol - LeftCol) - 1) + VER$
		Line$(NumLines) = LLC$ + STRING$((RightCol - LeftCol) - 1, HOR$) + LRC$

	CASE ELSE

	'=== Shouldn't be an "else" !

END SELECT


'=== Print the Window, Gentlemen ===

COLOR ForeColor%, BackColor%

SELECT CASE ExplodeType%

	CASE 0  '=== No elosion - just a straight print ===

		FOR X = 1 TO NumLines
			LOCATE (X + (TopRow - 1)), LeftCol: PRINT Line$(X)
		NEXT X

	CASE 1, 2, 3  '=== Explode that window! ===

		ExpX1 = INT(((RightCol - LeftCol) / 2) + LeftCol): ExpX2 = ExpX1
		ExpY1 = INT(((BotRow - TopRow) / 2) + TopRow): ExpY2 = ExpY1
		WHILE (ExpX1 > LeftCol + 1) OR (ExpY1 > TopRow + 1)
			IF ExpX1 > LeftCol THEN ExpX1 = ExpX1 - ExplodeStep%
			IF ExpX2 < RightCol THEN ExpX2 = ExpX2 + ExplodeStep%
			IF ExpY1 > TopRow THEN ExpY1 = ExpY1 - 1
			IF ExpY2 < BotRow THEN ExpY2 = ExpY2 + 1
			IF ExpX1 < LeftCol THEN ExpX1 = LeftCol: ExpX2 = RightCol
			IF ExpY1 < TopRow THEN ExpY1 = TopRow: ExpY2 = BotRow
			LOCATE ExpY1, ExpX1: PRINT ULC$ + STRING$((ExpX2 - ExpX1) - 1, HOR$) + URC$
			FOR X = ExpY1 + 1 TO ExpY2 - 1
				LOCATE X, ExpX1: PRINT VER$ + SPACE$((ExpX2 - ExpX1) - 1) + VER$
			NEXT X
			LOCATE ExpY2, ExpX1: PRINT LLC$ + STRING$((ExpX2 - ExpX1) - 1, HOR$) + LRC$
		WEND


		'=== Print a straight window now, after the explosion effect ===

		FOR X = 1 TO NumLines
			LOCATE (X + (TopRow - 1)), LeftCol: PRINT Line$(X)
		NEXT X

	CASE ELSE

	'=== Shouldn't be an "else" !

END SELECT


'=== Add a shadow if required ===

IF ShadowColor% >= 0 THEN
	COLOR ShadowColor%, 0
	SideShadow$ = STRING$(2, 219)
	BotShadow$ = STRING$((RightCol - LeftCol), 219)
	FOR X = TopRow + 1 TO BotRow + 1
		LOCATE X, RightCol + 1: PRINT SideShadow$
	NEXT X
	LOCATE BotRow + 1, LeftCol + 2: PRINT BotShadow$
END IF


'=== Add the Window Label, if possible ===

COLOR ForeColor%, BackColor%
IF Label$ <> "" THEN
	Label$ = LBL$ + Label$ + LBR$
	LOCATE TopRow, LeftCol + 1
	PRINT Label$
END IF

END SUB

REM $STATIC
SUB OffCenter (St$, Row%, LeftCol!, RightCol!)

'============== OFF-CENTER TEXT CENTERING SUB-PROGRAM ==============

'=== Calculate width available for string ===

Wdth = (RightCol - LeftCol)


'=== If ST$ fits in available width, determine X% for Locate ===

IF LEN(St$) > Wdth THEN
	EXIT SUB
ELSE
	X% = INT((Wdth - (LEN(St$))) / 2) + LeftCol
END IF


'=== Print the string ===

LOCATE Row%, X%: PRINT St$

END SUB

