'****
'****
'****  QuickDor.bi  Incude file!
'****
'****
'
DEFINT A-Z

DECLARE FUNCTION sysopname$ ()        ' Returns the sysops first name
DECLARE FUNCTION first$ ()            ' Returns the users first name
DECLARE FUNCTION last$ ()             ' Returns the users last name
DECLARE FUNCTION username$ ()         ' Returns the users full name
DECLARE FUNCTION filexist! (file$)    ' Use this to check for file existence.
DECLARE FUNCTION bbs.name$ ()         ' Returns the BBS name.
DECLARE FUNCTION getakey! ()          ' This gets a local or remote keypress
DECLARE FUNCTION CRLF$ ()             ' Returns a carriage return/line feed
DECLARE FUNCTION Fos% (Service AS INTEGER, port AS INTEGER) ' Main procedure to do
			      ' do almost everything! Read the Fos constants to
			      ' get a better idea of usage
DECLARE FUNCTION Kbdflush% () ' sets the local keyboard buffer to zero.
DECLARE FUNCTION Scrollit% () ' scrolls the screen when the 23rd line is reached
DECLARE FUNCTION loc.al% ()   ' determines if user is local or remote
DECLARE FUNCTION col.or% ()   ' determines if user has ANSI capability
DECLARE FUNCTION chekpress% () ' returns a 1 if a key is pressed, 0 if not

DECLARE SUB ansicurs ()               ' displays the cursor for the sysop
DECLARE SUB pagesys ()                ' Used to page sysop for chat
DECLARE SUB chat ()                   ' Used to call chat mode.
DECLARE SUB screen.off ()             ' Used internally to turn the local screen off
DECLARE SUB res.curs ()               ' Used internally to restore the ansi curs. pos.
DECLARE SUB sav.curs ()               ' Used internally to save the ansi curs. pos.
DECLARE SUB outtatime ()              ' Used internally when time runs out
DECLARE SUB timewarn ()               ' Used internally to send 2 minute warning
DECLARE SUB ansi (col$)               ' Changes the default ansi color
DECLARE SUB get.input (r$, t!)        ' r$ is string returned. t is max # chars
DECLARE SUB sho.file (file$)          ' Used to display a text or ansi file
DECLARE SUB backspace (n!)            ' Backspaces n number of times.
DECLARE SUB nl (t%)                   ' Does a cr/lf t number of times
DECLARE SUB read.cfg (game.cfg$)      ' Used to read the first two lines of the
				      ' configuration file. more lines can be
				      ' added and read with sysop defined routine.
DECLARE SUB epause ()                 ' Waits for ENTER to be pressed
DECLARE SUB byebye ()                 ' The ONLY proper exit from the Quickdor lib!
DECLARE SUB init.door ()              ' The fossil initialization routine
DECLARE SUB stat.bar ()               ' Draws the status bar on lines 24 and 25
DECLARE SUB clr.scrn ()               ' Claers the local and remote screens
DECLARE SUB dorinrd ()                ' Routine to read DORINFO1.DEF
DECLARE SUB show.str (mess$)          ' Sends a string of chars local and remote
DECLARE SUB carrier.detect ()         ' Checks carrier
DECLARE SUB more ()                   ' Chacks for 23 lines and if so..asks More?
DECLARE SUB cursoff ()                ' Used by chat mode to turn cursor off.
DECLARE SUB dosshell ()               ' Invoked via F5
DECLARE SUB upclck ()                 ' Updates the users time left (on statbar)
DECLARE SUB sendasc (c!)              ' Like show.char, but only needs ascii code
DECLARE SUB timeout ()                ' called if no keypress within 3 minutes


COMMON SHARED astring AS STRING       ' Global garbage collector Use anywhere!
COMMON SHARED menu AS STRING          ' Can be used as a menu building string!
COMMON SHARED noupcase AS INTEGER     ' If set to 1 then Get.input won't uppercase
COMMON SHARED scrnoff AS INTEGER      ' Used internally for screenoff flag
COMMON SHARED remtime AS INTEGER      ' Time user has left in door.
COMMON SHARED warn2 AS INTEGER        ' Used internally as time warning flag
COMMON SHARED setwarn AS INTEGER      ' Used internally as time warning flag
COMMON SHARED chaton AS INTEGER       ' Used internally as Chat flag
COMMON SHARED crlfcalls AS INTEGER    ' Used internally as # lines flag
COMMON SHARED moreoff AS INTEGER      ' Used to turn More prompt off.


DIM SHARED dorin$(16)                 ' 16 fields of DORINFO1.DEF file
DIM SHARED cnfg$(8)                   ' Up to 8 lines in cfg file
COMMON SHARED fossilport AS INTEGER   ' Internal port specifier
COMMON SHARED nomore AS INTEGER       ' Used internally by Sho.file
COMMON SHARED lines AS INTEGER        ' # lines displayed, used internally
'
'* Fos service's *  (used in Fos Function)
'  Many of these services will not be needed by the average game author, but
'  since the Fossil driver offers them I thought I would include all available
'  services that the Fossil can perform.  Use caution if you aren't familiar
'  with how to use these!  Most all of the functions in the game library will
'  handle most of your needs!  Certain services included here (like SetBaudRate)
'  do NOT need to be performed by you!  This is already taken care of!
'
'
'
CONST SetBaudRate = &H0                  ' Don't use..it's already set!
CONST XmitWithWait = &H100               ' Wait for other end if necessary.
CONST ReceiveWithWait = &H200            ' Get from buffer..wait if nothing there.
CONST GetStatus = &H300                  ' Get staus of comport.
CONST Init = &H400                       ' Initialize the Fossil driver.
CONST DeInit = &H500                     ' Deinitialize the Fossil driver.
CONST DTR = &H600                        ' Set DTR high or low.
CONST GetTimerTickPrm = &H700            ' Don't use unless you know what you are doing!
CONST FlushOutBuffer = &H800             ' Force contents of buffer out the port.
CONST PurgeOutBuffer = &H900             ' 0 the output buffer.
CONST PurgeInputBuffer = &HA00           ' 0 the input buffer.
CONST XmitNoWait = &HB00                 ' Just waht it says!
CONST PeekaBoo = &HC00                   ' Port Buffer lookahead
CONST KeyboardReadNoWait = &HD00         ' Local keyboard lookahead.
CONST KeyboardReadWithWait = &HE00       ' Local keyboard read.
CONST FlowControl = &HF00                ' Sets Flowcontrol. Good for doing transfers.
CONST BreakCheckToggle = &H1000          ' Turns checking for BREAK on and off
CONST SetCursor = &H1100                 ' Sets the cursor location.
CONST GetCursor = &H1200                 ' Gets the cursor location.
CONST VideoANSIWrite = &H1300            ' Writes in ANSI to the local screen
CONST Watchdog = &H1400                  ' Turns WatchDog on and off..reboot if no carrier.
CONST BIOSWrite = &H1500                 ' Writes via BIOS to local screen.
CONST TimerTickChain = &H1600            '....
CONST Reboot = &H1700                    '....
CONST ReadBuffBlock = &H1800             ' Good for doing transfers!
CONST WriteBuffBlock = &H1900            ' Ditto!
CONST SendBreakSignal = &H1A00           '....
CONST GetDriveInfo = &H1B00              ' Handy if looking for existing files.
CONST InstallAppendage = &H7E00          '....
CONST DeleteAppendage = &H7F00           '....
CONST CARRIERMASK = &H80                 ' May be different for cheaper modems
CONST BufferEmptyMASK = &H4000           ' Tells you if the com buffer is empty!

' ANSI color codes!
'   dim colors
CONST BLACK = "[0;30m"
CONST RED = "[0;31m"
CONST GREEN = "[0;32m"
CONST BROWN = "[0;33m"
CONST BLUE = "[0;34m"
CONST MAGENTA = "[0;35m"
CONST CYAN = "[0;36m"
CONST WHITE = "[0;37m"'

'   bright colors

CONST BBLACK = "[0;1;30m"
CONST BRED = "[0;1;31m"
CONST BGREEN = "[0;1;32m"
CONST YELLOW = "[0;1;33m"
CONST BBLUE = "[0;1;34m"
CONST BMAGENTA = "[0;1;35m"
CONST BCYAN = "[0;1;36m"
CONST BWHITE = "[0;1;37m"

' $INCLUDE: 'QB.BI'





